"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Reference(ProtocolElement):
    """
    A `Reference` is a canonical assembled contig, intended to act as a
    reference coordinate space for other genomic annotations. A single
    `Reference` might represent the human chromosome 1, for instance.
    `Reference`s are designed to be immutable.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "id",
        "length",
        "md5checksum",
        "name",
        "sourceAccessions",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_9_0 import ga4gh as ga4gh_3_1_1

        return {
            "org.ga4gh.models.Reference": ga4gh_3_1_1.Reference,
        }

    __slots__ = [
        "id",
        "length",
        "md5checksum",
        "name",
        "sourceAccessions",
        "isDerived",
        "ncbiTaxonId",
        "sourceDivergence",
        "sourceURI",
    ]

    def __init__(
        self,
        id,
        length,
        md5checksum,
        name,
        sourceAccessions,
        isDerived=False,
        ncbiTaxonId=None,
        sourceDivergence=None,
        sourceURI=None,
        validate=None,
        **kwargs
    ):
        """Initialise the ga4gh_3_1_1.Reference model.

        :param id:
            The reference ID. Unique within the repository.
        :type id: str
        :param length:
            The length of this reference's sequence.
        :type length: int
        :param md5checksum:
            The MD5 checksum uniquely representing this `Reference` as a
            lower-case hexadecimal string, calculated as the MD5 of
            the upper-case sequence excluding all whitespace
            characters (this is equivalent to SQ:M5 in SAM).
        :type md5checksum: str
        :param name:
            The name of this reference. (e.g. '22').
        :type name: str
        :param sourceAccessions:
            All known corresponding accession IDs in INSDC (GenBank/ENA/DDBJ)
            which must include a version number, e.g.
            `GCF_000001405.26`.
        :type sourceAccessions: list[str]
        :param isDerived:
            A sequence X is said to be derived from source sequence Y, if X and Y
            are of the same length and the per-base sequence
            divergence at A/C/G/T bases is sufficiently small. Two
            sequences derived from the same official sequence share
            the same coordinates and annotations, and can be replaced
            with the official sequence for certain use cases.
        :type isDerived: boolean
        :param ncbiTaxonId:
            ID from http://www.ncbi.nlm.nih.gov/taxonomy (e.g. 9606->human).
        :type ncbiTaxonId: None | int
        :param sourceDivergence:
            The `sourceDivergence` is the fraction of non-indel bases that do not
            match the reference this record was derived from.
        :type sourceDivergence: None | float
        :param sourceURI:
            The URI from which the sequence was obtained. Specifies a FASTA format
            file/string with one name, sequence pair. In most cases,
            clients should call the `getReferenceBases()` method to
            obtain sequence bases for a `Reference` instead of
            attempting to retrieve this URI.
        :type sourceURI: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.1.1"
